



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>React 深入系列２：组件分类</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">React 深入系列２：组件分类</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 23:49:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>文：徐超，《React进阶之路》作者</p></blockquote>
<blockquote><p>授权发布，转载请注明作者及出处</p></blockquote>
<hr>
<h3>React 深入系列2：组件分类</h3>
<blockquote><p>React 深入系列，深入讲解了React中的重点概念、特性和模式等，旨在帮助大家加深对React的理解，以及在项目中更加灵活地使用React。</p></blockquote>
<p>React 组件有很多种分类方式，常见的分类方式有函数组件和类组件，无状态组件和有状态组件，展示型组件和容器型组件。好吧，这又是一篇咬文嚼字的文章。但是，真正把这几组概念咬清楚、嚼明白后，对于页面的组件划分、组件之间的解耦是大有裨益的。</p>
<h4>函数组件和类组件</h4>
<p>函数组件(Functional Component )和类组件(Class Component)，划分依据是根据组件的定义方式。函数组件使用函数定义组件，类组件使用ES6 class定义组件。下面是函数组件和类组件的简单示例：</p>
<pre class="prettyprint linenums"><code>// 函数组件<br />
function Welcome(props) {<br />
  return &lt;h1&gt;Hello, {props.name}&lt;/h1&gt;;<br />
}

// 类组件<br />
class Welcome extends React.Component {<br />
  render() {<br />
    return &lt;h1&gt;Hello, {this.props.name}&lt;/h1&gt;;<br />
  }<br />
}<br />
</code></pre>
<p>上面的两种写法是等价的，但函数组件的写法要比类组件简洁，不过类组件比函数组件功能更加强大。类组件可以维护自身的状态变量，即组件的state，类组件还有不同的生命周期方法，可以让开发者能够在组件的不同阶段（挂载、更新、卸载），对组件做更多的控制。</p>
<p>类组件有这么多优点，是不是我们在开发中应该首选使用类组件呢？其实不然。函数组件更加专注和单一，承担的职责也更加清晰，它只是一个返回React 元素的函数，只关注对应UI的展现。函数组件接收外部传入的props，返回对应UI的DOM描述，仅此而已。当然，如上面例子所示，使用只包含一个render方法的类组件，可以实现和函数组件相同的效果。但函数组件的使用可以从思想上迫使你在设计组件时多做思考，更加关注逻辑和显示的分离，设计出更加合理的页面上组件树的结构。实际操作上，当一个组件不需要管理自身状态时，可以把它设计成函数组件，当你有足够的理由发现它需要“升级”为类组件时，再把它改造为类组件。因为函数组件“升级”为类组件是有一定成本的，这样就会要求你做这个改造前更认真地思考其合理性，而不是仅仅为了一时的方便就使用类组件。</p>
<h4>无状态组件和有状态组件</h4>
<p>无状态组件(Stateless Component )和有状态组件(Stateful Component)，划分依据是根据组件内部是否维护state。无状态组件内部不使用state，只根据外部组件传入的props返回待渲染的React 元素。有状态组件内部使用state，维护自身状态的变化，有状态组件根据外部组件传入的props和自身的state，共同决定最终返回的React 元素。</p>
<p>很容易知道，函数组件一定是无状态组件，类组件则既可以充当无状态组件，也可以充当有状态组件。但如上文所述，当一个组件不需要管理自身状态时，也就是无状态组件，应该优先设计为函数组件。</p>
<h4>展示型组件和容器型组件</h4>
<p>展示型组件(Presentational Component)和容器型组件(Container Component)，划分依据是根据组件的职责。</p>
<p>展示型组件的职责是：组件UI长成什么样。展示型组件不关心组件使用的数据是如何获取的，以及组件数据应该如何修改，它只需要知道有了这些数据后，组件UI是什么样子的即可。外部组件通过props传递给展示型组件所需的数据和修改这些数据的回调函数，展示型组件只是它们的使用者。展示型组件一般是无状态组件，不需要state，因为展示型组件不需要管理数据，但当展示型组件需要管理自身的UI状态时，例如控制组件内部弹框的显示与隐藏，是可以使用state的，这时的state属于UI state。既然大部分情况下展示型组件不需要state，应该优先考虑使用函数组件实现展示型组件。</p>
<p>容器型组件的职责是：组件数据如何工作。容器型组件需要知道如何获取子组件所需数据，以及这些数据的处理逻辑，并把数据和逻辑通过props提供给子组件使用。容器型组件一般是有状态组件，因为它们需要管理页面所需数据。</p>
<p>例如，下面的例子中，UserListContainer是一个容器型组件，它获取用户列表数据，然后把用户列表数据传递给展示型组件UserList，由UserList负责UI的展现。</p>
<pre class="prettyprint linenums"><code>class UserListContainer extends React.Component{<br />
  constructor(props){<br />
    super(props);<br />
    this.state = {<br />
      users: []<br />
    }<br />
  }

  componentDidMount() {<br />
    var that = this;<br />
    fetch('/path/to/user-api').then(function(response) {<br />
      response.json().then(function(data) {<br />
        that.setState({users: data})<br />
      });<br />
    });<br />
  }

  render() {<br />
    return (<br />
      &lt;UserList users={this.state.users} /&gt;<br />
    )<br />
  }<br />
}

function UserList(props) {<br />
  return (<br />
    &lt;div&gt;<br />
      &lt;ul className=&quot;user-list&quot;&gt;<br />
        {props.users.map(function(user) {<br />
          return (<br />
            &lt;li key={user.id}&gt;<br />
              &lt;span&gt;{user.name}&lt;/span&gt;<br />
            &lt;/li&gt;<br />
          );<br />
        })}<br />
      &lt;/ul&gt;<br />
    &lt;/div&gt;<br />
  )<br />
}<br />
</code></pre>
<p>展示型组件和容器型组件是可以互相嵌套的，展示型组件的子组件既可以包含展示型组件，也可以包含容器型组件，容器型组件也是如此。例如，当一个容器型组件承担的数据管理工作过于复杂时，可以在它的子组件中定义新的容器型组件，由新组件分担数据的管理。展示型组件和容器型组件的划分完全取决于组件所做的事情。</p>
<h4>总结</h4>
<p>通过上面的介绍，可以发现这三组概念有很多重叠部分。这三组概念都体现了关注点分离的思想：UI展现和数据逻辑的分离。函数组件、无状态组件和展示型组件主要关注UI展现，类组件、有状态组件和容器型组件主要关注数据逻辑。但由于它们的划分依据不同，它们并非完全等价的概念。它们之间的关联关系可以归纳为：函数组件一定是无状态组件，展示型组件一般是无状态组件；类组件既可以是有状态组件，又可以是无状态组件，容器型组件一般是有状态组件。</p>
<h4>下篇预告：</h4>
<p>React 深入系列3：State 和 Props</p>
<hr>
<p>新书推荐《React进阶之路》</p>
<p>作者：徐超</p>
<p>毕业于浙江大学，硕士，资深前端工程师，长期就职于能源物联网公司远景智能。8年软件开发经验，熟悉大前端技术，拥有丰富的Web前端和移动端开发经验，尤其对React技术栈和移动Hybrid开发技术有深入的理解和实践经验。</p>
<p><img referrerpolicy="no-referrer"src="https://user-gold-cdn.xitu.io/2018/4/4/1628e5ca2fd17f5b?w=297&amp;h=387&amp;f=png&amp;s=70401"></p>
<hr>
<p><img referrerpolicy="no-referrer"src="https://user-gold-cdn.xitu.io/2017/8/31/434a88713a614c84b89fb683b85d2c9e"></p>
<hr>
<p>美团点评广告平台大前端团队招收2019\2020年前端实习生</p>
<p>有意者邮件：yao.zhou@meituan.com</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlnpne8.html">scipy科学计算库</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93novzq.html">关于js的闭包</a>
		</li>
						<li><a href="https://www.batexi.com/a/495knez9.html">php大力力 &lbrack;042节&rsqb; 今天做了一个删除功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93ex2zq.html">Colorable Fantasy UI</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdez0779.html">zendframework 事件管理（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd00jmq.html">XUtils框架的学习（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmdel09.html">Android webView 正确的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvwndzq.html">&lbrack;转&rsqb; json in javascript</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zw56k9.html">CodeIgniter怎么引入公共的头部或者尾部文件&lpar;实现随意引入或分区域创建header&period;html&comma;bodyer&period;html&comma;footer&period;html&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jp4kw8.html">Logstash导入数据到ElasticSearch</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rjwd08.html">bzoj1195 神奇的ac自动机&plus;状态压缩dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvrlwz8.html">洛谷&period;3369&period;&lbrack;模板&rsqb;普通平衡树&lpar;Splay&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/960dvp39.html">剑指offer（27）字符串的排列</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w2k0wq.html">java&period;lang&period;Object&period;wait&lpar;Native Method&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlly2e1q.html">Linux 下socket通信终极指南（附TCP、UDP完整代码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1egvk9.html">ping出现dup问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/902jmwjq.html">Locust性能测试3-no-web模式和csv报告保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/902k7kmq.html">&lbrack;图解tensorflow源码&rsqb; 线程池模块分析 &lpar;CPU thread pool device&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pz2lz8.html">centos  腾讯云 今天买了 18个月</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g33gr4q.html">P3986 斐波那契数列</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnjkp438.html">Pluto - iOS 上一个高性能的排版渲染引擎</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp3n5vq.html">浏览器中直接是使用react系列包开发，非打包方式。</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdy0749.html">Django 2&period;0 学习&lpar;02&rpar;：Django视图和URL&lpar;上&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mnoej8.html">java-StringBuffer学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kngo09.html">sudo用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey7pkk9.html">linux修改时区</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yrppz8.html">pyrhon多进程操作初探</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1ko5p59.html">使用ADO&period;NET查询和访问数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkjlye8.html">Restful风格，PUT修改功能请求，表单中存在文件报错-HTTP Status 405 - Request method &amp;&num;39&semi;POST&amp;&num;39&semi; not supported</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1n4yxq.html">linux dd使用记录</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
